import { ICacheableDataCollection } from './../interfaces/data-collection';
import { ICacheableDataResource } from './../interfaces/data-resource';
import { IDataResource } from '../interfaces/data-resource';
import { IDataCollection } from '../interfaces/data-collection';
import { IObjectsById } from '../interfaces';
interface IDataResourceStorage extends IDataResource {
    _lastupdate_time: number;
}
export declare class StoreService {
    private db;
    constructor();
    getDataObject(type: 'collection', url: string): Promise<ICacheableDataCollection>;
    getDataObject(type: string, id: string): Promise<ICacheableDataResource>;
    getDataResources(keys: Array<string>): Promise<IObjectsById<IDataResourceStorage>>;
    saveResource(type: string, url_or_id: string, value: IDataResource): void;
    saveCollection(url_or_id: string, value: IDataCollection): void;
    clearCache(): void;
    deprecateResource(type: string, id: string): void;
    deprecateCollection(key_start_with: string): void;
    removeObjectsWithKey(key: string): Promise<void>;
    private checkIfIsTimeToClean;
    private checkAndDeleteOldElements;
}
export {};
